/* This file is part of Lcrzo.
*/

int lcrzo_process_current_exit(int returnvalue)
{ 
#if defined LCRZODEF_SYSTEM_Unix
  lcrzo_priv_globalvars *ptr;
  int ret;

  ret=lcrzo_priv_globalvars_ptr_get(&ptr);
  if (ret!=LCRZO_ERR_OK) _exit(returnvalue);
  /* we can call lcrzo_priv_globalvars_close();, but it is not useful
     because the process exits now */
  /* to be sure every message is displayed */
  fflush(stdout);
  fflush(stderr);
  _exit((*ptr->pprocess_int2uint8)(returnvalue));

#elif defined LCRZODEF_SYSTEM_Windows
  lcrzo_close_forthreadonly();
  /* to be sure every message is displayed */
  fflush(stdout);
  fflush(stderr);
 #if 0
  ExitThread(returnvalue);
 #else
  _endthreadex(returnvalue);
 #endif

#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
  return(lcrzo_ierp("lcrzo_process_current_exit"));
}


